import 'package:flutter/material.dart';
import 'package:test_sa/extensions/context_extension.dart';
import 'package:test_sa/extensions/int_extensions.dart';
import 'package:test_sa/extensions/string_extensions.dart';
import 'package:test_sa/extensions/text_extensions.dart';
import 'package:test_sa/extensions/widget_extensions.dart';
import 'package:test_sa/new_views/app_style/app_color.dart';

class ADatePicker extends StatelessWidget {
  final DateTime? date; // Nullable
  final DateTime? from; // Nullable
  final DateTime? to; // Nullable
  final String label;
  final bool hideShadow;
  final String? hint; // Nullable
  final Function(DateTime)? onDatePicker; // Nullable
  final bool enable;
  final bool withBorder;
  final bool withIcon;
  final Color? backgroundColor; // Nullable
  final bool formatDateWithTime;
  final double? height; // Nullable

  const ADatePicker({
    Key? key,
    required this.label,
    this.withBorder = true,
    this.height,
    this.backgroundColor,
    this.hideShadow = false,
    this.hint,
    this.date,
    this.withIcon = true,
    this.formatDateWithTime = false,
    this.onDatePicker,
    this.from,
    this.to,
    this.enable = true,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      height: height,
      decoration: BoxDecoration(
        color: backgroundColor ??
            (context.isDark && !enable
                ? AppColor.neutral50
                : !enable
                    ? AppColor.neutral40
                    : AppColor.background(context)),
        borderRadius: BorderRadius.circular(10),
        border: withBorder ? Border.all(width: 1, color: Theme.of(context).scaffoldBackgroundColor) : const Border(),
        boxShadow: hideShadow ? null : [BoxShadow(color: Colors.black.withOpacity(0.05), blurRadius: 10)],
      ),
      padding: EdgeInsets.symmetric(horizontal: 16.toScreenWidth, vertical: 8.toScreenHeight),
      child: Row(
        children: [
          Column(
            crossAxisAlignment: CrossAxisAlignment.stretch,
            mainAxisSize: MainAxisSize.min,
            children: [
              label.tinyFont(context),
              (date == null
                      ? hint ?? context.translation.pickADate
                      : (formatDateWithTime
                          ? date?.toIso8601String().toFirstActionFormat // Use null-aware operator
                          : (date?.toIso8601String().split("T").first ?? context.translation.pickADate)))!
                  .bodyText(context)
                  .custom(color: context.isDark ? AppColor.neutral30 : AppColor.neutral50),
            ],
          ).expanded,
          // enable ? 16.width : const Spacer(),
          withIcon ? "calender".toSvgAsset(width: 20, color: context.isDark ? AppColor.neutral10 : null) : const SizedBox(),
        ],
      ),
    ).onPress(enable
        ? () async {
            final DateTime? picked = await showDatePicker(
              // Nullable DateTime
              context: context,
              initialDate: DateTime.now(),
              firstDate: from ?? DateTime.now(),
              lastDate: to ?? DateTime.now(),
            );
            if (picked != null && onDatePicker != null) {
              onDatePicker!(picked); // Use null-aware operator
            }
          }
        : null);
  }
}
